//---------------------------------------------------------------------------
//NEZAPOMENTE SE TAKE KOUKNOUT DO HLAVICKOVEHO SOUBORU
#include <vcl.h>
#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>
#include <list.h>

#include "atlas.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{             //konstruktor formule je przdn
}

FILE* soubor;           //soubor, ze ktereho nacitame
list<mesto> mesta;      //seznam mest
list<cesta> cesty;      //seznam cest
double plus_x, plus_y, ratio;  //promenne pro prevod souradnic
mesto konecne[2];       //startovni a cilove mesto
double spotreby[10000]; //pole zaznamenavajici spotreby
int pocet_mest, pocet_cest;  //pocty cest a mest

AnsiString NactiTag() //vrati hodnotu nasledujiciho tagu
{
  char c;
  AnsiString retezec;
  c=0;

  while(c!='<')                //hledame zacatek tagu
     fscanf(soubor,"%c",&c);

  fscanf(soubor,"%c",&c);  //nacteme dalsi znak
  while(c!='>')            //hledame konec tagu
  {
    retezec+=c;            //pridavame znaky do retezce
    fscanf(soubor,"%c",&c);//cteme dalsi znaky
  }

  return retezec;  //vysledny retezec vratime
}

AnsiString NactiHodnotu() //nacte hodnotu mezi tagy
{
  char c;
  AnsiString retezec;
  c=0;
  static bool english=false;
  try
  {
    retezec="1,1";
    if(!english)
      retezec.ToDouble();
  }
  catch(...)
  {
    english=true;
  }
  retezec="";
  fscanf(soubor,"%c",&c);    //cteme znak
  while(c!='<')              //pokracujeme, dokud nenarazime dalsi tag
  {
    if(!english)
      if(c=='.') c=',';        //kvuli cestine prevadime tecky na carky
    retezec+=c;              //pridavame znaky
    fscanf(soubor,"%c",&c);  //cteme dalsi znak
  }

  return retezec;            //vysledny retezec vratime
}

void TForm1::NactiMapu()
{
  while(mesta.begin()!=mesta.end()) mesta.pop_front(); //vyprazdnime seznamy
  while(cesty.begin()!=cesty.end()) cesty.pop_front();
  AnsiString retezec;
  do
  {
    retezec=NactiTag();                     //cteme tag
    if(strcmp(retezec.c_str(),"mesto")==0)  //zpracovani tagu mesto
    {
      mesto pridavane;
      retezec=NactiTag();
      pridavane.nazev=NactiHodnotu();        //nacteme prislusne hodnoty
      retezec=NactiTag();
      pridavane.x=NactiHodnotu().ToDouble();
      retezec=NactiTag();
      pridavane.y=NactiHodnotu().ToDouble();
      mesta.push_back(pridavane);            //pridame mesto do seznamu
      pocet_mest++;                          //zvysime pocet mest
    }
    if(strcmp(retezec.c_str(),"cesta")==0)   //nalezen tag cesta
    {
      cesta pridavane;
      retezec=NactiTag();
      pridavane.nazev1=NactiHodnotu();
      retezec=NactiTag();                   //nacteme prislusne hodnoty
      pridavane.nazev2=NactiHodnotu();
      retezec=NactiTag();
      pridavane.vzdalenost=NactiHodnotu().ToDouble();
      retezec=NactiTag();
      pridavane.rychlost=NactiHodnotu().ToDouble();
      cesty.push_back(pridavane);            //pridame cestu do seznamu
      pocet_cest++;                          //zvysime pocet cest
    }
    if(strcmp(retezec.c_str(),"spotreba")==0)  //nalezen tag spotreba
    {
      int rychlost;
      double litru;

      retezec=NactiTag();
      rychlost=int(NactiHodnotu().ToDouble());
      retezec=NactiTag();
      spotreby[rychlost]=NactiHodnotu().ToDouble();
    }
  }while(retezec!="/mapa");           //koncime pri nalezeni konce mapy


  list<cesta>::iterator citer;
  citer=cesty.begin();
  for(; citer!=cesty.end(); citer++)  //ke koncum cest priradime souradnice mest
  {
    list<mesto>::iterator iter;    //probirame mesta a hledame
    iter=mesta.begin();
    for(; iter!=mesta.end(); iter++)
    {
      if(iter->nazev==citer->nazev1)
      {
        citer->x1=iter->x;           //nastaveni jednoho konce
        citer->y1=iter->y;
      }
      if(iter->nazev==citer->nazev2)
      {
        citer->x2=iter->x;        //nastaveni druheho konce
        citer->y2=iter->y;
      }
    }
  }
}

void TForm1::VyberCestu()  //vybira optimalni cestu - bohuzel nedokonceno
{       //nejlepsi cesta se hleda pomoci Dijkstrova algoritmu
        //v mych casovych moznostech ale neni naprogramovat haldu
  list<mesto>::iterator iter;
  iter=mesta.begin();
  for(int i=0; iter!=mesta.end(); iter++,i++)
  {
    iter->vzdalenost=10e10;           //nastavime vzdalenost na nekonecno
    if(iter->nazev==konecne[0].nazev) //startovni mesto ma vzdalenost 0
      iter->vzdalenost=0;
  }

  list<cesta>::iterator citer;     //probirame cesty a hledame, jak
  citer=cesty.begin();             //zkratit vzdalenost mest
  for(; citer!=cesty.end(); citer++)
  {
    iter=mesta.begin();
    for(int i=0; iter!=mesta.end(); iter++,i++)
    {
      if(iter->nazev==citer->nazev1)
      {

      }
    }
  }
}

void TForm1::ZobrazMapu()  //vykresli mapu
{
  Image1->Canvas->Brush->Style=bsSolid;   //smazeme obrazovku
  Image1->Canvas->Rectangle(0,0,1000,1000);

  double min_x=10e10, max_x=-10e10, min_y=10e10, max_y=10e10;
  //nastaveni pocatecnich hodnot
  list<mesto>::iterator iter;
  iter=mesta.begin();
  for(int i=0; iter!=mesta.end(); iter++,i++)
  {
//    Memo1->Lines->Strings[i]=iter->nazev;
    if(iter->x<min_x) min_x=iter->x;  //hledani minima a maxima
    if(iter->y<min_y) min_y=iter->y;
    if(iter->x>max_x) max_x=iter->x;
    if(iter->y>max_y) max_y=iter->y;
  }

  plus_x=-min_x+20;      //vypocet paramatru pro transformovani souradnic
  plus_y=-min_y+20;
  if((max_x-min_x)<(max_y-min_y))
    ratio=350/(max_x-min_x);
  else
    ratio=350/(max_y-min_y);

  iter=mesta.begin();
  for(int i=0; iter!=mesta.end(); iter++,i++) //vykreslime vsechna mesta
  {
    Image1->Canvas->Brush->Style=bsSolid;
    if((konecne[0].nazev==iter->nazev) || (konecne[1].nazev==iter->nazev))
      Image1->Canvas->Brush->Color=(TColor)RGB(0,255,0);
    //koncova mesta jsou zobrazena zelene

    Image1->Canvas->Ellipse(iter->x*ratio+plus_x-5, //nakreslime male kolecko
                            iter->y*ratio+plus_y-5,
                            iter->x*ratio+plus_x+5,
                            iter->y*ratio+plus_y+5);
    Image1->Canvas->Brush->Style=bsClear;
    if(CheckBox2->Checked) //jestli uzivatel chce, vypiseme nazvy mest
      Image1->Canvas->TextOutA(iter->x*ratio+plus_x,iter->y*ratio+plus_y,
                               iter->nazev);
  }

  list<cesta>::iterator citer;
  citer=cesty.begin();
  if(CheckBox1->Checked)
  for(; citer!=cesty.end(); citer++) //vykreslime vsechny cesty
  {
    if(citer->rychlost>70)         //zvolime barvu podle rychlosti
      Image1->Canvas->Pen->Color=(TColor)RGB(0,0,255);
    if(citer->rychlost>90)
      Image1->Canvas->Pen->Color=(TColor)RGB(255,0,0);
    //nastavime pozici na zacatek cesty
    Image1->Canvas->MoveTo(citer->x1*ratio+plus_x,citer->y1*ratio+plus_y);
    //udelame caru na konec cesty
    Image1->Canvas->LineTo(citer->x2*ratio+plus_x,citer->y2*ratio+plus_y);
    Image1->Canvas->Pen->Color=(TColor)RGB(0,0,0); //vratime barvu pera
  }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::OpenButtonClick(TObject *Sender)
{
  //spustime otviraci dialog
  if(OpenDialog1->Execute())
  {
    //pokud probehl spravne, nacteme zdrojovy kon
    Memo1->Lines->LoadFromFile(OpenDialog1->FileName);
    //otevreme soubor
    soubor=fopen(OpenDialog1->FileName.c_str(),"rt");
    //nacteme mapu ze souboru
    NactiMapu();
    //zobrazime mapu
    ZobrazMapu();
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  //aktivujeme platno
  Image1->Canvas;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CheckBox2Click(TObject *Sender)
{
  //pri zmene parametru prekreslime mapu
  ZobrazMapu();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::CheckBox1Click(TObject *Sender)
{
  //pri zmene parametru prekreslime mapu
  ZobrazMapu();
}

double sqr(double x) //druha mocnina
{
  return x*x;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  double min_vzdal=10e10, vzdal; //nastaveni pocatecnich parametru
  double mx, my; //pomocne souradnice
  mesto vybrane;  //urci vybrane mesto

  list<mesto>::iterator iter; //vytvorime iterator pro mesta
  iter=mesta.begin();
  for(int i=0; iter!=mesta.end(); iter++,i++)
  { //hledame, jake mesto je nejblize mistu kliknuti
    mx=iter->x*ratio+plus_x;
    my=iter->y*ratio+plus_y;
    vzdal=sqrt(sqr(mx-X)+sqr(my-Y));  //Pythagorova veta
    if(min_vzdal>vzdal) //hledame minumum ve vzalenosti
    {
      min_vzdal=vzdal;  //nastavime novou minimalni vzdalenost
      vybrane=*iter;
    }
  }

  if(Button==mbRight)
  { //prave tlacitko vybere startovni/koncove mesto
    if(min_vzdal<30) //pokud jsme klikli dostatecne blizko
    {
      static pom;
      konecne[pom%2]=vybrane;
      pom++;
      ZobrazMapu(); //je nutne prekreslit mapu
    }
    return;
  }

  //leve tlacitko
  if(min_vzdal<30) //pokud jsme klikli dostatecne blizko
  {
    //vytvorime zpravu o odchozich cestach
    AnsiString titulek=("Vybrali jste msto "+vybrane.nazev);
    AnsiString obsah="Vedou z nj cesty do:\n";
    list<cesta>::iterator citer;
    citer=cesty.begin();
    for(; citer!=cesty.end(); citer++)
    {
      AnsiString doba; //vypocet casu a prevod na hodiny a minuty
      doba="";
      double cas;
      cas=citer->vzdalenost/citer->rychlost;
      if(cas>1)
      {
        doba = doba + int(cas) + " hodin ";  //hodiny
        cas = cas - int(cas);
      }
      doba = doba + int(cas*60) + " minut"; //minuty
      if(citer->nazev1==vybrane.nazev)     //hledame spravna mesta
      {
        obsah = obsah + citer->nazev2+'\n' +  //nastavime obsah zpravy
                "Vzdlenost: "+ citer->vzdalenost+
                " km     Doba jzdy: "+ doba.c_str() +
                "\n\n";
      }
      if(citer->nazev2==vybrane.nazev)
      {
        obsah = obsah + citer->nazev1+'\n' +
                "Vzdlenost: "+ citer->vzdalenost+
                " km      Doba jzdy: "+ doba.c_str() +
                "\n\n";
      }
    }
    MessageBox(0,obsah.c_str(),titulek.c_str(),0); //zpravu vypiseme
  }
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{
    list<cesta>::iterator citer;   //pri zmene optimalizace
    citer=cesty.begin();           //zmenime metriku pro hledani cesty
    for(; citer!=cesty.end(); citer++)
    {
      switch(RadioGroup1->ItemIndex)
      {                       //pro kazdy pripad nastavime metriku
        case 0:      //vzdalenost
          citer->ohodnoceni=citer->vzdalenost;
        break;
        case 1:    //cas
          citer->ohodnoceni=citer->vzdalenost/citer->rychlost;
        break;
        case 2:  //cena
          citer->ohodnoceni=citer->vzdalenost/100*spotreby[int(citer->rychlost)];
        break;
      }
    }
    ZobrazMapu();
}
//---------------------------------------------------------------------------

